<template>
  <div>
    <GManageTable
      :card="card"
      :i18n-base="i18nBase"
      v-bind="$attrs"
      :headers="headers"
      :items="value.influenceCondition"
      :get-new-item="getNewItem"
      use-wrapper
      :optional="optional"
      :wiki-entry="wikiEntry"
      @create="create"
      @edit="edit"
      @remove="remove"
      @deleteElement="$emit('delete')"
    >
      <template #form="{ item, updateAvailableElements }">
        <Condition
          v-model="item.value"
          :card="false"
          :update-available-elements="updateAvailableElements"
        />
      </template>

      <template #[`item.name`]="{ item }">
        {{ getForCurrentLocale(item.name) }}
      </template>
      <template #[`item.description`]="{ item }">
        <div class="text-truncate default-max-width">
          {{ getForCurrentLocale(item.description) }}
        </div>
      </template>
    </GManageTable>
  </div>
</template>

<script>
import { ConditionType } from "@d-ptb/dcc-js";
import { validatableMixin } from "../../Mixins/validatableMixin";
import Condition from "./Condition";
import { removeFromArray } from "~/assets/util/general";
import { generateCondition } from "~/assets/util/DataGenerator";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";

export default {
  name: "InfluenceConditionList",
  components: {
    GManageTable,
    Condition,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    optional: {
      type: Boolean,
      default: true,
    },
    i18nBase: {
      type: String,
      default: "dcc.common.influenceConditionListType",
    },
    wikiEntry: {
      type: String,
      default: "influenceConditions",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.conditionType.name"),
          value: "name",
        },
        {
          text: this.$t("dcc.common.conditionType.description"),
          value: "description",
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [() => this.value.influenceCondition.length > 0];
    },
  },
  watch: {
    "value.influenceCondition"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.influenceCondition, item);
    },
    create(item) {
      this.value.influenceCondition.push(new ConditionType(item));
    },
    edit(item, index) {
      this.$set(this.value.influenceCondition, index, undefined);
      this.$set(this.value.influenceCondition, index, new ConditionType(item));
    },
    getNewItem() {
      return generateCondition();
    },
  },
};
</script>
